## kmess 2.0.6

=== CMakeLists.txt ===
PROJECT( kmess )


#### System checks ####

# To add checks, see in one or more of these paths
# /usr/share/cmake/Modules
# /usr/share/kde4/apps/cmake/modules
# /usr/share/apps/cmake

# Check for cmake, same as minimum for KDE 4.0.0
CMAKE_MINIMUM_REQUIRED( VERSION 2.4.5 )

# Check for KDE 4
FIND_PACKAGE( KDE4 REQUIRED )
INCLUDE( KDE4Defaults )

# Make sure the rest still works
IF( NOT KDE4_FOUND )
  # The macro's MACRO_LOG_FEATURE, MACRO_OPTIONAL_FIND_PACKAGE, MACRO_BOOL_TO_01
  # are part of the KDE cmake modules, so these can't be used now.

  MESSAGE( FATAL_ERROR "\n"
  "  The KDE Development Platform was not found.\n"
  "  \n"
  "  You will need this package and the matching development package.\n"
  "  Usually the package names for this library are:\n"
  "    on Debian and Ubuntu:   'kdebase-runtime' and 'kdelibs5-dev'\n"
  "    on openSUSE: 'kdebase4-runtime' and 'libkde4-devel'\n"
  "  \n"
  "  Please refer to the KMess board for more info,\n"
  "  and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )
ENDIF( NOT KDE4_FOUND )

# Check for libxml2
FIND_PACKAGE( LibXml2 )
MACRO_LOG_FEATURE( LIBXML2_FOUND "LibXML2" "Libraries used to develop XML-aware applications" "http://www.xmlsoft.org/" TRUE ""
    "Required for the chat styles system.
      * You will need this package and the matching development package: for example, 'libxml2' and 'libxml2-dev' or 'libxml2-devel'.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libxml2' and 'libxml2-dev'
        on openSUSE:          'libxml2' and 'libxml2-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )

# Check for libxslt
FIND_PACKAGE( LibXslt )
MACRO_LOG_FEATURE( LIBXSLT_FOUND "LibXSLT" "A library to transform XML into other formats" "http://www.xmlsoft.org/XSLT" TRUE ""
    "Required for the chat styles system.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libxslt' and 'libxslt1-dev'
        on openSUSE:         'libxslt' and 'libxslt-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )

# Add cmake directory to the MODULE_PATH, so cmake can find GCrypt
SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} $ENV{CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake )

# Check for GCrypt
FIND_PACKAGE( GCrypt )
IF( NOT GCRYPT_FOUND )
  MACRO_LOG_FEATURE( GCRYPT_FOUND "GCrypt" "A library to encrypt messages with various cyphers" "http://www.gnupg.org/" TRUE ""
    "It is required for the Live Messenger login process.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libgcrypt' and 'libgcrypt11-dev'
        on openSUSE:          'libgcrypt' and 'libgcrypt-devel'
        on Fedora:            'gcrypt' and 'gcrypt-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )
ELSE()
  MESSAGE( STATUS "Looking for GCrypt - found" )
ENDIF()

# Check for XScreenSaver extension
OPTION( WANT_XSCREENSAVER "Build with X11 screensaver auto-away support" ON )
IF( WANT_XSCREENSAVER )
  MACRO_BOOL_TO_01( X11_Xscreensaver_FOUND HAVE_XSCREENSAVER )
  MACRO_OPTIONAL_FIND_PACKAGE(X11)
  IF( X11_FOUND )
    MACRO_LOG_FEATURE( X11_Xscreensaver_FOUND "XScreenSaver" "X11 extension used to check idle state" "" FALSE ""
    "Required for the auto-away feature.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libxss-dev'
        on openSUSE:          'xorg-x11-libs'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )
  ELSE( X11_FOUND )
    MESSAGE( STATUS "NOTE: The auto-away feature is not supported on this platform yet." )
  ENDIF( X11_FOUND )
ENDIF( WANT_XSCREENSAVER )

# Check for libkonq
# QUIET is to fix compiling on systems like Debian Lenny, which don't have FindLibKonq.cmake
#   (for an optional feature, we don't want that to be fatal)
MACRO_OPTIONAL_FIND_PACKAGE( LibKonq QUIET )
MACRO_LOG_FEATURE( LIBKONQ_FOUND "LibKonq" "Integration with Konqueror context menu" "http://www.kde.org/" FALSE ""
    "This is an optional feature.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libkonq5' and 'libkonq5-dev'
        on openSUSE:          'libkonq5' and 'libkonq-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )

# Check for libisf-qt
MACRO_OPTIONAL_FIND_PACKAGE( IsfQt QUIET )
MACRO_LOG_FEATURE( ISFQT_FOUND "LibISF-Qt" "Library to manage Microsoft's Mobile Ink" "http://www.kmess.org/" FALSE ""
    "Support to send handwriting messages in a format compatible with Windows Live Messenger.
     In absence of an installed isf-qt version, the bundled version will be compiled.")
MACRO_BOOL_TO_01( ISFQT_FOUND HAVE_LIBISFQT ) # For config-kmess.h.in

# Check for KNotificationItem. KDE 4.3.1 and later have it integrated in kdelibs/experimental.
# It will be available by default in 4.4.
IF( ${KDE_VERSION} VERSION_LESS 4.3.70 ) # KDE trunk has a higher version number than this.
  MACRO_OPTIONAL_FIND_PACKAGE(LibKNotificationItem-1)
  MACRO_LOG_FEATURE( LIBKNOTIFICATIONITEM-1_FOUND "LibKNotificationItem-1" "The experimental new KDE systray library" "http://www.kde.org" FALSE ""
    "LibKNotificationItem-1 is the experimental new KDE systray library. It will be included
     by default in KDE 4.4 and is available for use in KDE 4.3.1 and above." )
  MACRO_BOOL_TO_01( LIBKNOTIFICATIONITEM-1_FOUND HAVE_NEW_TRAY )
ELSE()
  SET( HAVE_NEW_TRAY 1 )
ENDIF()

# Display the dependency collection results
MACRO_DISPLAY_FEATURE_LOG()



#### Configure build ####

INCLUDE( MacroLibrary )
INCLUDE( KDE4Defaults )

IF( NOT ISFQT_FOUND )
# isf-qt is not installed on the system.
# use the bundled version.
  SET( ISFQT_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/contrib/isf-qt/include )
  SET( ISFQT_LIBRARIES isf-qt )

  SET( USE_BUNDLED_LIBRARIES ${USE_BUNDLED_LIBRARIES} ISFQT )
  SET( HAVE_LIBISFQT 1 )
  SET( ISFQT_FOUND TRUE )
ENDIF( NOT ISFQT_FOUND )

ADD_DEFINITIONS( ${QT_DEFINITIONS} ${KDE4_DEFINITIONS} )

INCLUDE_DIRECTORIES( ${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} ${LIBXML2_INCLUDE_DIR} )


#### Define the app version number ####

# Switch between the following two commands to force using a predefined version number
# EXECUTE_PROCESS( COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/cmake/get-git-version.sh OUTPUT_VARIABLE KMESS_VERSION )
SET( KMESS_VERSION "2.0.6" )


#### Define compiler flags ####

# Tune the debug build with even more flags
# also see FindKDE4Internal.cmake for more defaults
IF( CMAKE_COMPILER_IS_GNUCXX )
  # skipped: -ansi -pendantic -Wfatal-errors -Wold-style-cast -Wconversion
  SET( CMAKE_CXX_FLAGS_DEBUG     "-O0 -g -Wall" )
  SET( CMAKE_CXX_FLAGS_DEBUGFULL "-O0 -g3 -fno-inline -Wall -Woverloaded-virtual -Wsign-compare -Wundef" )
  # the -fvisibility option makes symbols also visible to the KDE backtrace dumper, but
  # the MinGW gcc doesn't seem to understand it well, so only add it if we're not on win32
  IF( NOT WIN32 )
    SET( CMAKE_CXX_FLAGS_DEBUGFULL "${CMAKE_CXX_FLAGS_DEBUGFULL} -fvisibility=default" )
  ENDIF( NOT WIN32 )
ENDIF( CMAKE_COMPILER_IS_GNUCXX )


# Define the default build type
# Possible values:
# - none
# - release
# - debug
# - debugfull       (even fewer optimisations)
# - relwithdebinfo  (release with debug info)
# - minsizerel      (minsize release)
# Uncomment the next line to always force building in full debug mode
SET( CMAKE_BUILD_TYPE debugfull )

# Enable the KMess debug output when compiling a debug build
IF( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )
  SET( KMESS_ENABLE_DEBUG_OUTPUT "1" )
ELSE( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )
  SET( KMESS_ENABLE_DEBUG_OUTPUT "0" )
ENDIF( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )


# Change symbol visibility, to obtain clearer KDE backtraces
SET( __KDE_HAVE_GCC_VISIBILITY 0 )

# Disable LikeBack if not needed
IF( KMESS_DISABLE_LIKEBACK EQUAL 1 )
  SET( KMESS_DISABLE_LIKEBACK "1" )
ELSE( KMESS_DISABLE_LIKEBACK EQUAL 1 )
  SET( KMESS_DISABLE_LIKEBACK "0" )
ENDIF( KMESS_DISABLE_LIKEBACK EQUAL 1 )

# Set a default installation path
IF( NOT CMAKE_INSTALL_PREFIX )
  SET( CMAKE_INSTALL_PREFIX "/usr" )
ENDIF( NOT CMAKE_INSTALL_PREFIX )

IF( CMAKE_USE_CPACK EQUAL 1 )
  MESSAGE( STATUS "Enabling the CPack package target..." )
  # source: http://www.vtk.org/Wiki/CMake:Packaging_With_CPack
  INCLUDE( InstallRequiredSystemLibraries )
  # the installer will be named ${PACKAGENAME}-{VERSIONMAJOR}.{VERSIONMINOR}.{VERSIONPATCH}-win32.exe.
  # the installer will say "Welcome to the ${INSTALL_DIRECTORY} Setup Wizard and install to ${INSTALL_DIRECTORY} too, and
  # put the program in start menu under the ${INSTALL_DIRECTORY} name.
  # it will ask if ${PACKAGENAME} should be put in PATH.
  SET( CPACK_PACKAGE_NAME "KMess" )
  SET( CPACK_PACKAGE_DESCRIPTION_SUMMARY "KMess (package description)" )
  SET( CPACK_PACKAGE_VENDOR "The KMess team" )
  SET( CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README" )
  SET( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING" )
  SET( CPACK_PACKAGE_VERSION_MAJOR "1" )
  SET( CPACK_PACKAGE_VERSION_MINOR "0" )
  SET( CPACK_PACKAGE_VERSION_PATCH "0" )
  SET( CPACK_PACKAGE_INSTALL_DIRECTORY "KMess" )
  IF( WIN32 AND NOT UNIX )
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backslashes.
    SET( CPACK_GENERATOR "NSIS" )
    SET( CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/data/icons\\\\hi32-app-kmess.png" )
    SET( CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\kmess.exe" )
    SET( CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} KMess (display name)" )
    SET( CPACK_NSIS_HELP_LINK "http:\\\\\\\\kmess.org" )
    SET( CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\kmess.org" )
    SET( CPACK_NSIS_CONTACT "project@kmess.org" )
    SET( CPACK_NSIS_MODIFY_PATH ON )
  ELSE( WIN32 AND NOT UNIX )
    SET( CPACK_STRIP_FILES "bin/kmess" )
    SET( CPACK_SOURCE_STRIP_FILES "" )
  ENDIF( WIN32 AND NOT UNIX )

  SET( CPACK_PACKAGE_EXECUTABLES "kmess" "KMess" )
  INCLUDE( CPack )
ENDIF( CMAKE_USE_CPACK EQUAL 1 )

#### Other settings ####

# Generate config-kmess.h
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config-kmess.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-kmess.h )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

# continue in directories
ADD_SUBDIRECTORY( po )
ADD_SUBDIRECTORY( data )
ADD_SUBDIRECTORY( doc )
ADD_SUBDIRECTORY( src )

IF( LIBKONQ_FOUND )
  ADD_SUBDIRECTORY( src/utils/kmess-send )
ENDIF( LIBKONQ_FOUND )

IF( USE_BUNDLED_LIBRARIES MATCHES "ISFQT" )
  ADD_SUBDIRECTORY( contrib/isf-qt )
ENDIF( )


# Also add the tests if compiling in development mode
IF( CMAKE_BUILD_TYPE STREQUAL debugfull AND KMESS_DEBUG_OUTPUT EQUAL 1 )
  ADD_SUBDIRECTORY( tests )
ENDIF( CMAKE_BUILD_TYPE STREQUAL debugfull AND KMESS_DEBUG_OUTPUT EQUAL 1 )

=== .pc/01_no_debugfull_build.diff/CMakeLists.txt ===
PROJECT( kmess )


#### System checks ####

# To add checks, see in one or more of these paths
# /usr/share/cmake/Modules
# /usr/share/kde4/apps/cmake/modules
# /usr/share/apps/cmake

# Check for cmake, same as minimum for KDE 4.0.0
CMAKE_MINIMUM_REQUIRED( VERSION 2.4.5 )

# Check for KDE 4
FIND_PACKAGE( KDE4 REQUIRED )
INCLUDE( KDE4Defaults )

# Make sure the rest still works
IF( NOT KDE4_FOUND )
  # The macro's MACRO_LOG_FEATURE, MACRO_OPTIONAL_FIND_PACKAGE, MACRO_BOOL_TO_01
  # are part of the KDE cmake modules, so these can't be used now.

  MESSAGE( FATAL_ERROR "\n"
  "  The KDE Development Platform was not found.\n"
  "  \n"
  "  You will need this package and the matching development package.\n"
  "  Usually the package names for this library are:\n"
  "    on Debian and Ubuntu:   'kdebase-runtime' and 'kdelibs5-dev'\n"
  "    on openSUSE: 'kdebase4-runtime' and 'libkde4-devel'\n"
  "  \n"
  "  Please refer to the KMess board for more info,\n"
  "  and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )
ENDIF( NOT KDE4_FOUND )

# Check for libxml2
FIND_PACKAGE( LibXml2 )
MACRO_LOG_FEATURE( LIBXML2_FOUND "LibXML2" "Libraries used to develop XML-aware applications" "http://www.xmlsoft.org/" TRUE ""
    "Required for the chat styles system.
      * You will need this package and the matching development package: for example, 'libxml2' and 'libxml2-dev' or 'libxml2-devel'.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libxml2' and 'libxml2-dev'
        on openSUSE:          'libxml2' and 'libxml2-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )

# Check for libxslt
FIND_PACKAGE( LibXslt )
MACRO_LOG_FEATURE( LIBXSLT_FOUND "LibXSLT" "A library to transform XML into other formats" "http://www.xmlsoft.org/XSLT" TRUE ""
    "Required for the chat styles system.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libxslt' and 'libxslt1-dev'
        on openSUSE:         'libxslt' and 'libxslt-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )

# Add cmake directory to the MODULE_PATH, so cmake can find GCrypt
SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} $ENV{CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake )

# Check for GCrypt
FIND_PACKAGE( GCrypt )
IF( NOT GCRYPT_FOUND )
  MACRO_LOG_FEATURE( GCRYPT_FOUND "GCrypt" "A library to encrypt messages with various cyphers" "http://www.gnupg.org/" TRUE ""
    "It is required for the Live Messenger login process.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libgcrypt' and 'libgcrypt11-dev'
        on openSUSE:          'libgcrypt' and 'libgcrypt-devel'
        on Fedora:            'gcrypt' and 'gcrypt-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )
ELSE()
  MESSAGE( STATUS "Looking for GCrypt - found" )
ENDIF()

# Check for XScreenSaver extension
OPTION( WANT_XSCREENSAVER "Build with X11 screensaver auto-away support" ON )
IF( WANT_XSCREENSAVER )
  MACRO_BOOL_TO_01( X11_Xscreensaver_FOUND HAVE_XSCREENSAVER )
  MACRO_OPTIONAL_FIND_PACKAGE(X11)
  IF( X11_FOUND )
    MACRO_LOG_FEATURE( X11_Xscreensaver_FOUND "XScreenSaver" "X11 extension used to check idle state" "" FALSE ""
    "Required for the auto-away feature.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libxss-dev'
        on openSUSE:          'xorg-x11-libs'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )
  ELSE( X11_FOUND )
    MESSAGE( STATUS "NOTE: The auto-away feature is not supported on this platform yet." )
  ENDIF( X11_FOUND )
ENDIF( WANT_XSCREENSAVER )

# Check for libkonq
# QUIET is to fix compiling on systems like Debian Lenny, which don't have FindLibKonq.cmake
#   (for an optional feature, we don't want that to be fatal)
MACRO_OPTIONAL_FIND_PACKAGE( LibKonq QUIET )
MACRO_LOG_FEATURE( LIBKONQ_FOUND "LibKonq" "Integration with Konqueror context menu" "http://www.kde.org/" FALSE ""
    "This is an optional feature.
      * Usually the package names for this library are:
        on Debian and Ubuntu: 'libkonq5' and 'libkonq5-dev'
        on openSUSE:          'libkonq5' and 'libkonq-devel'
      * Please refer to the KMess board for more info,
        and specially to this guide: http://trac.kmess.org/wiki/Compiling%20KMess" )

# Check for libisf-qt
MACRO_OPTIONAL_FIND_PACKAGE( IsfQt QUIET )
MACRO_LOG_FEATURE( ISFQT_FOUND "LibISF-Qt" "Library to manage Microsoft's Mobile Ink" "http://www.kmess.org/" FALSE ""
    "Support to send handwriting messages in a format compatible with Windows Live Messenger.
     In absence of an installed isf-qt version, the bundled version will be compiled.")
MACRO_BOOL_TO_01( ISFQT_FOUND HAVE_LIBISFQT ) # For config-kmess.h.in

# Check for KNotificationItem. KDE 4.3.1 and later have it integrated in kdelibs/experimental.
# It will be available by default in 4.4.
IF( ${KDE_VERSION} VERSION_LESS 4.3.70 ) # KDE trunk has a higher version number than this.
  MACRO_OPTIONAL_FIND_PACKAGE(LibKNotificationItem-1)
  MACRO_LOG_FEATURE( LIBKNOTIFICATIONITEM-1_FOUND "LibKNotificationItem-1" "The experimental new KDE systray library" "http://www.kde.org" FALSE ""
    "LibKNotificationItem-1 is the experimental new KDE systray library. It will be included
     by default in KDE 4.4 and is available for use in KDE 4.3.1 and above." )
  MACRO_BOOL_TO_01( LIBKNOTIFICATIONITEM-1_FOUND HAVE_NEW_TRAY )
ELSE()
  SET( HAVE_NEW_TRAY 1 )
ENDIF()

# Display the dependency collection results
MACRO_DISPLAY_FEATURE_LOG()



#### Configure build ####

INCLUDE( MacroLibrary )
INCLUDE( KDE4Defaults )

IF( NOT ISFQT_FOUND )
# isf-qt is not installed on the system.
# use the bundled version.
  SET( ISFQT_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/contrib/isf-qt/include )
  SET( ISFQT_LIBRARIES isf-qt )

  SET( USE_BUNDLED_LIBRARIES ${USE_BUNDLED_LIBRARIES} ISFQT )
  SET( HAVE_LIBISFQT 1 )
  SET( ISFQT_FOUND TRUE )
ENDIF( NOT ISFQT_FOUND )

ADD_DEFINITIONS( ${QT_DEFINITIONS} ${KDE4_DEFINITIONS} )

INCLUDE_DIRECTORIES( ${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} ${LIBXML2_INCLUDE_DIR} )


#### Define the app version number ####

# Switch between the following two commands to force using a predefined version number
# EXECUTE_PROCESS( COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/cmake/get-git-version.sh OUTPUT_VARIABLE KMESS_VERSION )
SET( KMESS_VERSION "2.0.5" )


#### Define compiler flags ####

# Tune the debug build with even more flags
# also see FindKDE4Internal.cmake for more defaults
IF( CMAKE_COMPILER_IS_GNUCXX )
  # skipped: -ansi -pendantic -Wfatal-errors -Wold-style-cast -Wconversion
  SET( CMAKE_CXX_FLAGS_DEBUG     "-O0 -g -Wall" )
  SET( CMAKE_CXX_FLAGS_DEBUGFULL "-O0 -g3 -fno-inline -Wall -Woverloaded-virtual -Wsign-compare -Wundef" )
  # the -fvisibility option makes symbols also visible to the KDE backtrace dumper, but
  # the MinGW gcc doesn't seem to understand it well, so only add it if we're not on win32
  IF( NOT WIN32 )
    SET( CMAKE_CXX_FLAGS_DEBUGFULL "${CMAKE_CXX_FLAGS_DEBUGFULL} -fvisibility=default" )
  ENDIF( NOT WIN32 )
ENDIF( CMAKE_COMPILER_IS_GNUCXX )


# Define the default build type
# Possible values:
# - none
# - release
# - debug
# - debugfull       (even fewer optimisations)
# - relwithdebinfo  (release with debug info)
# - minsizerel      (minsize release)
# Uncomment the next line to always force building in full debug mode
# SET( CMAKE_BUILD_TYPE debugfull )

# Enable the KMess debug output when compiling a debug build
IF( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )
  SET( KMESS_ENABLE_DEBUG_OUTPUT "1" )
ELSE( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )
  SET( KMESS_ENABLE_DEBUG_OUTPUT "0" )
ENDIF( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )


# Change symbol visibility, to obtain clearer KDE backtraces
SET( __KDE_HAVE_GCC_VISIBILITY 0 )

# Disable LikeBack if not needed
IF( KMESS_DISABLE_LIKEBACK EQUAL 1 )
  SET( KMESS_DISABLE_LIKEBACK "1" )
ELSE( KMESS_DISABLE_LIKEBACK EQUAL 1 )
  SET( KMESS_DISABLE_LIKEBACK "0" )
ENDIF( KMESS_DISABLE_LIKEBACK EQUAL 1 )

# Set a default installation path
IF( NOT CMAKE_INSTALL_PREFIX )
  SET( CMAKE_INSTALL_PREFIX "/usr" )
ENDIF( NOT CMAKE_INSTALL_PREFIX )

IF( CMAKE_USE_CPACK EQUAL 1 )
  MESSAGE( STATUS "Enabling the CPack package target..." )
  # source: http://www.vtk.org/Wiki/CMake:Packaging_With_CPack
  INCLUDE( InstallRequiredSystemLibraries )
  # the installer will be named ${PACKAGENAME}-{VERSIONMAJOR}.{VERSIONMINOR}.{VERSIONPATCH}-win32.exe.
  # the installer will say "Welcome to the ${INSTALL_DIRECTORY} Setup Wizard and install to ${INSTALL_DIRECTORY} too, and
  # put the program in start menu under the ${INSTALL_DIRECTORY} name.
  # it will ask if ${PACKAGENAME} should be put in PATH.
  SET( CPACK_PACKAGE_NAME "KMess" )
  SET( CPACK_PACKAGE_DESCRIPTION_SUMMARY "KMess (package description)" )
  SET( CPACK_PACKAGE_VENDOR "The KMess team" )
  SET( CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README" )
  SET( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING" )
  SET( CPACK_PACKAGE_VERSION_MAJOR "1" )
  SET( CPACK_PACKAGE_VERSION_MINOR "0" )
  SET( CPACK_PACKAGE_VERSION_PATCH "0" )
  SET( CPACK_PACKAGE_INSTALL_DIRECTORY "KMess" )
  IF( WIN32 AND NOT UNIX )
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backslashes.
    SET( CPACK_GENERATOR "NSIS" )
    SET( CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/data/icons\\\\hi32-app-kmess.png" )
    SET( CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\kmess.exe" )
    SET( CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} KMess (display name)" )
    SET( CPACK_NSIS_HELP_LINK "http:\\\\\\\\kmess.org" )
    SET( CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\kmess.org" )
    SET( CPACK_NSIS_CONTACT "project@kmess.org" )
    SET( CPACK_NSIS_MODIFY_PATH ON )
  ELSE( WIN32 AND NOT UNIX )
    SET( CPACK_STRIP_FILES "bin/kmess" )
    SET( CPACK_SOURCE_STRIP_FILES "" )
  ENDIF( WIN32 AND NOT UNIX )

  SET( CPACK_PACKAGE_EXECUTABLES "kmess" "KMess" )
  INCLUDE( CPack )
ENDIF( CMAKE_USE_CPACK EQUAL 1 )

#### Other settings ####

# Generate config-kmess.h
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config-kmess.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-kmess.h )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

# continue in directories
ADD_SUBDIRECTORY( po )
ADD_SUBDIRECTORY( data )
ADD_SUBDIRECTORY( doc )
ADD_SUBDIRECTORY( src )

IF( LIBKONQ_FOUND )
  ADD_SUBDIRECTORY( src/utils/kmess-send )
ENDIF( LIBKONQ_FOUND )

IF( USE_BUNDLED_LIBRARIES MATCHES "ISFQT" )
  ADD_SUBDIRECTORY( contrib/isf-qt )
ENDIF( )


# Also add the tests if compiling in development mode
IF( CMAKE_BUILD_TYPE STREQUAL debugfull AND KMESS_DEBUG_OUTPUT EQUAL 1 )
  ADD_SUBDIRECTORY( tests )
ENDIF( CMAKE_BUILD_TYPE STREQUAL debugfull AND KMESS_DEBUG_OUTPUT EQUAL 1 )

=== debian/changelog ===
kmess (2.0.6-0ubuntu1) natty; urgency=low

  * New upstream release
    - Refresh 01_no_debugfull_build.diff

 -- Romain Perier <romain.perier@gmail.com>  Fri, 11 Feb 2011 18:13:12 +0100

kmess (2.0.4-0ubuntu3) natty; urgency=low

  * Rebuild again for libkonq5a transition since armel got missed the first
    time

 -- Scott Kitterman <scott@kitterman.com>  Fri, 17 Dec 2010 22:19:09 -0500

kmess (2.0.4-0ubuntu2) natty; urgency=low

  * Rebuild for libkonq5a transition

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 03 Nov 2010 14:23:12 +0000

## kmess 2.0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -150,7 +150,7 @@
 
 # Switch between the following two commands to force using a predefined version number
 # EXECUTE_PROCESS( COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/cmake/get-git-version.sh OUTPUT_VARIABLE KMESS_VERSION )
-SET( KMESS_VERSION "2.0.6" )
+SET( KMESS_VERSION "2.0.6.1" )
 
 
 #### Define compiler flags ####
@@ -178,7 +178,7 @@
 # - relwithdebinfo  (release with debug info)
 # - minsizerel      (minsize release)
 # Uncomment the next line to always force building in full debug mode
-SET( CMAKE_BUILD_TYPE debugfull )
+SET( CMAKE_BUILD_TYPE relwithdebinfo )
 
 # Enable the KMess debug output when compiling a debug build
 IF( CMAKE_BUILD_TYPE STREQUAL debugfull OR KMESS_DEBUG_OUTPUT EQUAL 1 )

=== Makefile ===
# Generated by ./configure: NO NOT EDIT!
# Build features:
#
#   Install prefix:      /usr
#   Auto-away feature:   yes
#   Debugging messages:  no   (good!)
#   Build type:          relwithdebinfo
#   Build directory:     build
#
#
# cmake command:
#
#   cd "/home/adam/kmess-2.0.6.1/build"
#   cmake -D CMAKE_INSTALL_PREFIX=/usr \
#         -D CMAKE_BUILD_TYPE=relwithdebinfo \
#         -D KMESS_DEBUG_OUTPUT=0 \
#         "/home/adam/kmess-2.0.6.1"
#

default_target:
	@$(MAKE) --no-print-directory -C 'build' default_target

cmake_force:
	@$(MAKE) --no-print-directory -C 'build' cmake_force

edit_cache:
	@$(MAKE) --no-print-directory -C 'build' edit_cache

edit_cache/fast:
	@$(MAKE) --no-print-directory -C 'build' edit_cache/fast

install:
	@$(MAKE) --no-print-directory -C 'build' install

install/fast:
	@$(MAKE) --no-print-directory -C 'build' install/fast

install/local:
	@$(MAKE) --no-print-directory -C 'build' install/local

install/local/fast:
	@$(MAKE) --no-print-directory -C 'build' install/local/fast

install/strip:
	@$(MAKE) --no-print-directory -C 'build' install/strip

install/strip/fast:
	@$(MAKE) --no-print-directory -C 'build' install/strip/fast

list_install_components:
	@$(MAKE) --no-print-directory -C 'build' list_install_components

list_install_components/fast:
	@$(MAKE) --no-print-directory -C 'build' list_install_components/fast

rebuild_cache:
	@$(MAKE) --no-print-directory -C 'build' rebuild_cache

rebuild_cache/fast:
	@$(MAKE) --no-print-directory -C 'build' rebuild_cache/fast

test:
	@$(MAKE) --no-print-directory -C 'build' test

test/fast:
	@$(MAKE) --no-print-directory -C 'build' test/fast

all:
	@$(MAKE) --no-print-directory -C 'build' all

clean:
	@$(MAKE) --no-print-directory -C 'build' clean

clean/fast:
	@$(MAKE) --no-print-directory -C 'build' clean/fast

preinstall:
	@$(MAKE) --no-print-directory -C 'build' preinstall

preinstall/fast:
	@$(MAKE) --no-print-directory -C 'build' preinstall/fast

depend:
	@$(MAKE) --no-print-directory -C 'build' depend

uninstall:
	@$(MAKE) --no-print-directory -C 'build' uninstall

uninstall/fast:
	@$(MAKE) --no-print-directory -C 'build' uninstall/fast

translations:
	@$(MAKE) --no-print-directory -C 'build' translations

translations/fast:
	@$(MAKE) --no-print-directory -C 'build' translations/fast

en-handbook:
	@$(MAKE) --no-print-directory -C 'build' en-handbook

en-handbook/fast:
	@$(MAKE) --no-print-directory -C 'build' en-handbook/fast

kmess:
	@$(MAKE) --no-print-directory -C 'build' kmess

kmess/fast:
	@$(MAKE) --no-print-directory -C 'build' kmess/fast

kmess_automoc:
	@$(MAKE) --no-print-directory -C 'build' kmess_automoc

kmess_automoc/fast:
	@$(MAKE) --no-print-directory -C 'build' kmess_automoc/fast

kmesssendplugin:
	@$(MAKE) --no-print-directory -C 'build' kmesssendplugin

kmesssendplugin/fast:
	@$(MAKE) --no-print-directory -C 'build' kmesssendplugin/fast

kmesssendplugin_automoc:
	@$(MAKE) --no-print-directory -C 'build' kmesssendplugin_automoc

kmesssendplugin_automoc/fast:
	@$(MAKE) --no-print-directory -C 'build' kmesssendplugin_automoc/fast

kmesssendpluginlib:
	@$(MAKE) --no-print-directory -C 'build' kmesssendpluginlib

kmesssendpluginlib/fast:
	@$(MAKE) --no-print-directory -C 'build' kmesssendpluginlib/fast

help:
	@$(MAKE) --no-print-directory -C 'build' help

cmake_check_build_system:
	@$(MAKE) --no-print-directory -C 'build' cmake_check_build_system

=== data/CMakeLists.txt ===

ADD_SUBDIRECTORY( pics       )
ADD_SUBDIRECTORY( icons      )
ADD_SUBDIRECTORY( sounds     )
ADD_SUBDIRECTORY( emoticons  )
ADD_SUBDIRECTORY( chatstyles )

INSTALL( FILES  kmesschatstyles.knsrc  DESTINATION ${CONFIG_INSTALL_DIR}     )
INSTALL( FILES  kmess.notifyrc         DESTINATION ${DATA_INSTALL_DIR}/kmess )
INSTALL( FILES  kmess.desktop          DESTINATION ${XDG_APPS_INSTALL_DIR}   )

=== doc/CMakeLists.txt ===

include_directories( ${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES}  )

add_subdirectory( en )

=== po/CMakeLists.txt ===
FIND_PROGRAM( GETTEXT_MSGFMT_EXECUTABLE msgfmt )
 
IF( NOT GETTEXT_MSGFMT_EXECUTABLE )
  MESSAGE(
"------
                 NOTE: msgfmt not found. Translations will *not* be installed
------")
ELSE( NOT GETTEXT_MSGFMT_EXECUTABLE )
 
  SET( catalogname kmess )
 
  ADD_CUSTOM_TARGET( translations ALL )

  FILE( GLOB PO_FILES *.po )

  FOREACH( _poFile ${PO_FILES} )
    GET_FILENAME_COMPONENT( _lang ${_poFile} NAME_WE )
    SET( _gmoFile ${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo )
    ADD_CUSTOM_COMMAND( TARGET translations
                        COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} --check -o ${_gmoFile} ${_poFile}
                        DEPENDS ${_poFile})
    INSTALL( FILES ${_gmoFile} DESTINATION ${LOCALE_INSTALL_DIR}/${_lang}/LC_MESSAGES/ RENAME ${catalogname}.mo )
  ENDFOREACH( _poFile ${PO_FILES} )
 
ENDIF( NOT GETTEXT_MSGFMT_EXECUTABLE )

=== src/CMakeLists.txt ===

INCLUDE_DIRECTORIES( ${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} ${GCRYPT_INCLUDE_DIRS} )

########### next target ###############

SET(kmess_SOURCES
   chat/chathistorymanager.cpp
   chat/chathistorywriter.cpp
   chat/chatmaster.cpp
   chat/chatmessagestyle.cpp
   chat/chatmessageview.cpp
   chat/chatview.cpp
   chat/chat.cpp
   chat/chatwindow.cpp
   chat/contactframe.cpp
   chat/contactswidget.cpp
   chat/emoticonswidget.cpp
   chat/chatstatusbar.cpp
   chat/xsltransformation.cpp
   chat/winkswidget.cpp
   contact/contactbase.cpp
   contact/contact.cpp
   contact/contactextension.cpp
   contact/group.cpp
   contact/invitedcontact.cpp
   contact/msnobject.cpp
   contact/msnstatus.cpp
   dialogs/addcontactdialog.cpp
   dialogs/addemoticondialog.cpp
   dialogs/awaymessagedialog.cpp
   dialogs/chathistorydialog.cpp
   dialogs/contactaddeduserdialog.cpp
   dialogs/contactaddeduserwidget.cpp
   dialogs/contactentry.cpp
   dialogs/contactpropertiesdialog.cpp
   dialogs/invitedialog.cpp
   dialogs/listexportdialog.cpp
   dialogs/userpicturesdialog.cpp
   dialogs/transferentry.cpp
   dialogs/transferwindow.cpp
   model/contactlist.cpp
   model/contactlistmodelitem.cpp
   model/contactlistmodelfilter.cpp
   network/chatinformation.cpp
   network/chatmessage.cpp
   network/mimemessage.cpp
   network/msnchallengehandler.cpp
   network/msnsocketbase.cpp
   network/msnsockettcp.cpp
   network/msnsockethttp.cpp
   network/msnconnection.cpp
   network/msnnotificationconnection.cpp
   network/msnswitchboardconnection.cpp
   network/multipacketmessage.cpp
   network/p2pmessage.cpp
   network/applications/application.cpp
   network/applications/applicationlist.cpp
   network/applications/filetransfer.cpp
   network/applications/filetransferp2p.cpp
   network/applications/inktransferp2p.cpp
   network/applications/mimeapplication.cpp
   network/applications/p2papplicationbase.cpp
   network/applications/p2papplication.cpp
   network/applications/msnobjecttransferp2p.cpp
   network/applications/unknownapplication.cpp
   network/extra/directconnectionbase.cpp
   network/extra/directconnectionpool.cpp
   network/extra/msndirectconnection.cpp
   network/extra/msnftpconnection.cpp
   network/extra/p2pfragmenttracker.cpp
   network/soap/addressbookservice.cpp
   network/soap/httpsoapconnection.cpp
   network/soap/msnappdirectoryservice.cpp
   network/soap/offlineimservice.cpp
   network/soap/passportloginservice.cpp
   network/soap/roamingservice.cpp
   network/soap/soapmessage.cpp
   notification/chatnotification.cpp
   notification/contactstatusnotification.cpp
   notification/notificationmanager.cpp
   notification/newemailnotification.cpp
   notification/addressbooknotifications.cpp
   settings/accountpage.cpp
   settings/accountsettingsdialog.cpp
   settings/accountsmanagerpage.cpp
   settings/contactlistpage.cpp
   settings/chatloggingpage.cpp
   settings/chatstylepage.cpp
   settings/emoticonspage.cpp
   settings/globalsettingsdialog.cpp
   settings/miscellaneouspage.cpp
   utils/crashhandler.cpp
   utils/idletimer.cpp
   utils/inlineeditlabel.cpp
   utils/kmessconfig.cpp
   utils/kmessdbus.cpp
   utils/kmessdbusdatatypes.cpp
   utils/kmessshared.cpp
   utils/nowlisteningclient.cpp
   utils/richtextparser.cpp
   utils/thumbnailprovider.cpp
   utils/xautolock.cpp
   utils/xmlfunctions.cpp
   utils/gradientelidelabel.cpp
   utils/faderwidget.cpp
   account.cpp
   accountaction.cpp
   accountsmanager.cpp
   currentaccount.cpp
   emoticon.cpp
   emoticonmanager.cpp
   emoticontheme.cpp
   initialview.cpp
   kmessapplication.cpp
   kmess.cpp
   kmessdebug.cpp
   kmessinterface.cpp
   kmessview.cpp
   kmessviewdelegate.cpp
   main.cpp
)

SET(kmess_UI_FILES
   initialview.ui
   kmessview.ui
   chat/chatwindow.ui
   chat/contactframe.ui
   chat/contactswidget.ui
   dialogs/addcontactdialog.ui
   dialogs/addemoticondialog.ui
   dialogs/awaymessagedialog.ui
   dialogs/chathistorydialog.ui
   dialogs/contactaddeduserwidget.ui
   dialogs/transferentry.ui
   dialogs/transferwindow.ui
   dialogs/contactentry.ui
   dialogs/contactpropertiesdialog.ui
   dialogs/invitedialog.ui
   dialogs/listexportdialog.ui
   dialogs/userpicturesdialog.ui
   settings/accountpage.ui
   settings/accountsmanagerpage.ui
   settings/contactlistpage.ui
   settings/chatloggingpage.ui
   settings/chatstylepage.ui
   settings/emoticonspage.ui
   settings/miscellaneouspage.ui
   utils/inlineeditlabel.ui
)

SET(kmess_LIBS
   ${KDE4_KDECORE_LIBS}
   ${KDE4_KDEUI_LIBS}
   ${KDE4_KIO_LIBS}
   ${KDE4_KHTML_LIBS}
   ${KDE4_KNOTIFYCONFIG_LIBS}
   ${KDE4_KNEWSTUFF2_LIBS}
   ${KDE4_PHONON_LIBS}
   ${KDE4_SOLID_LIBS}
   ${LIBXML2_LIBRARIES}
   ${LIBXSLT_LIBRARIES}
   ${GCRYPT_LIBRARIES}
   ${QT_QTTEST_LIBRARY}
)

IF( ${GIF_FOUND} )
  INCLUDE_DIRECTORIES( ${GIF_INCLUDE_DIR} )
  SET( kmess_LIBS ${kmess_LIBS} ${GIF_LIBRARIES} )
ENDIF( ${GIF_FOUND} )

IF( ISFQT_FOUND )
  INCLUDE_DIRECTORIES( ${ISFQT_INCLUDE_DIR} )
  SET( kmess_LIBS ${kmess_LIBS} ${ISFQT_LIBRARIES} )
ENDIF( ISFQT_FOUND )

# If LikeBack is enabled, compile it
IF( NOT ${KMESS_DISABLE_LIKEBACK} EQUAL 1 )
  # Enable LikeBack
  SET( kmess_SOURCES ${kmess_SOURCES}
       utils/likeback/likeback.cpp
       utils/likeback/likebackbar.cpp
       utils/likeback/likebackdialog.cpp )
  SET( kmess_UI_FILES ${kmess_UI_FILES}
       utils/likeback/likebackbar.ui
       utils/likeback/likebackdialog.ui )
ENDIF( NOT ${KMESS_DISABLE_LIKEBACK} EQUAL 1 )

# On Mac OS, add Mac-specific files
if(APPLE)
  set(kmess_SOURCES ${kmess_SOURCES}  notification/macnotification.cpp)
endif(APPLE)

#new system tray spec - optional
IF( HAVE_NEW_TRAY )
  SET( kmess_SOURCES ${kmess_SOURCES}
       notification/newsystemtraywidget.cpp )
  INCLUDE_DIRECTORIES( ${KNOTIFICATIONITEM_INCLUDE_DIR} )
  SET( kmess_LIBS ${kmess_LIBS} ${KNOTIFICATIONITEM_LIBRARIES} )
ELSE()
  SET( kmess_SOURCES ${kmess_SOURCES}
       notification/systemtraywidget.cpp )
ENDIF()

# If we're compiling in debug mode:
IF( ${KMESS_ENABLE_DEBUG_OUTPUT} EQUAL 1 )
  # Enable the Network Window
  SET(kmess_SOURCES  ${kmess_SOURCES}  dialogs/networkwindow.cpp)
  SET(kmess_UI_FILES ${kmess_UI_FILES} dialogs/networkwindow.ui)
  # Enable the testing class
  SET(kmess_SOURCES  ${kmess_SOURCES}  kmesstest.cpp)
  # Enable the old parser
  SET(kmess_SOURCES  ${kmess_SOURCES}  ../tests/old_richtextparser.cpp)
  # Enable the Models tester
  IF( CMAKE_BUILD_TYPE STREQUAL debugfull )
    SET( kmess_SOURCES ${kmess_SOURCES} ../tests/modeltest/modeltest.cpp )
  ENDIF( CMAKE_BUILD_TYPE STREQUAL debugfull )
ENDIF( ${KMESS_ENABLE_DEBUG_OUTPUT} EQUAL 1 )

# Add XScreensaver library for away-idle detection.
IF( X11_Xscreensaver_FOUND )
  SET(kmess_LIBS    ${kmess_LIBS} ${X11_Xscreensaver_LIB} ${X11_LIBRARIES} )
ENDIF( X11_Xscreensaver_FOUND )


IF( ${KDE_VERSION} VERSION_LESS 4.4.0 )
  # Set our KDE debug number to be the default
  add_definitions( -DKDE_DEFAULT_DEBUG_AREA=5130 )
ENDIF()

# Define the app icon for Windows / Mac OS
SET( kmess_SRCS )
KDE4_ADD_APP_ICON( kmess_SRCS ../data/icons/hi*-app-kmess.png )
SET( kmess_SOURCES ${kmess_SOURCES} ${kmess_SRCS} )

# Create a DBus adapter from XML file
QT4_ADD_DBUS_ADAPTOR( kmess_SOURCES utils/kmessdbus.xml utils/kmessdbus.h KMessDBus )

# Define all files
KDE4_ADD_UI_FILES( kmess_SOURCES ${kmess_UI_FILES} )
KDE4_ADD_EXECUTABLE( kmess ${kmess_SOURCES} )

# Link to final executable
TARGET_LINK_LIBRARIES( kmess ${kmess_LIBS} )

INSTALL( TARGETS kmess DESTINATION ${BIN_INSTALL_DIR})

INSTALL( FILES  chat/chatwindowui.rc DESTINATION ${DATA_INSTALL_DIR}/kmess )
INSTALL( FILES  kmessinterfaceui.rc  DESTINATION ${DATA_INSTALL_DIR}/kmess )

=== tests/CMakeLists.txt ===
# Do nothing here :)

=== contrib/isf-qt/CMakeLists.txt ===
PROJECT( isf-qt )
CMAKE_MINIMUM_REQUIRED( VERSION 2.6 )


#### Main switches ####

# Bundled mode: you can add Isf-Qt as a subdirectory
# of your CMake-based prjoect easily. Just use:
# SET( USE_BUNDLED_LIBRARIES ISFQT )
# and Isf-Qt will be built and statically linked in your
# application, without installing anything
IF( ISFQT_IS_BUNDLED OR USE_BUNDLED_LIBRARIES MATCHES "ISFQT" )
  SET( ISFQT_IS_BUNDLED TRUE )
  MESSAGE( "-- Will build Isf-Qt in bundled mode." )
ELSE()
  SET( ISFQT_IS_BUNDLED FALSE )
ENDIF()

# Only set the build type if we're not being bundled: if we are, we'll
# use the build type specified by the parent project
IF( NOT ISFQT_IS_BUNDLED )

  # Define the default build type
  # Possible values:
  # - none
  # - release
  # - debug
  # - debugfull       (even fewer optimisations)
  # - relwithdebinfo  (release with debug info)
  # - minsizerel      (minimum size release)
  # Uncomment the next line to force building in full debug mode
  SET( CMAKE_BUILD_TYPE debugfull )
ENDIF()

# Define the library version number
SET( ISFQT_VERSION "1.0dev" )


#### Inclusions ####

FIND_PACKAGE( Qt4 REQUIRED )

OPTION( WANT_GIF "Enable support for reading and writing Fortified-GIF images" ON )
IF( WANT_GIF )
  MESSAGE( "-- Looking for GifLib" )

  # Apparently, the KDE CMake macros unset a check which is required by giflib.
  IF( KDE4_FOUND )
    INCLUDE( "cmake/giflib_hack.cmake" )
  ENDIF( KDE4_FOUND )

  FIND_PACKAGE( GIF QUIET )

  # At this point, we can be relatively sure that if it's there, it has been found
  IF( NOT GIF_FOUND )
    MESSAGE( "-- Looking for GifLib - not found!" )
    MESSAGE( FATAL_ERROR
             "Support to read and write Fortified-GIF images is missing.\n"
             "  * You will need to install both the library and development packages of the GIF Library, giflib.\n"
             "  * Usually the package names for this library are:\n"
             "      on Ubuntu:   'libgif4' and 'libgif-dev'\n"
             "      on openSUSE: 'giflib'  and 'giflib-devel'\n"
             "  * The project homepage is http://sourceforge.net/projects/giflib/\n" )
  ELSE()
    MESSAGE( "-- Looking for GifLib - found" )
  ENDIF()
ELSE( WANT_GIF )
  MESSAGE( "-- GifLib support disabled" )
ENDIF( WANT_GIF )

# Set the variable for isfqtconfig.h.in
IF( WANT_GIF )
  SET( GIF_ENABLED 1 )
ELSE()
  SET( GIF_ENABLED 0 )
ENDIF()


#### Compilation ####

IF( CMAKE_COMPILER_IS_GNUCXX )
  SET( CMAKE_CXX_FLAGS_DEBUGFULL
       "-O0 -g3 -fno-inline -Wall -Woverloaded-virtual -Wsign-compare -Wundef -fvisibility=default" )
ENDIF( CMAKE_COMPILER_IS_GNUCXX )

IF( NOT ISFQT_DEBUG_OUTPUT STREQUAL "1" AND NOT ISFQT_DEBUG_OUTPUT STREQUAL "0" )
  IF( CMAKE_BUILD_TYPE MATCHES debug )
    SET( ISFQT_DEBUG_OUTPUT 1 )
  ELSE()
    SET( ISFQT_DEBUG_OUTPUT 0 )
  ENDIF()
ENDIF()



INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} src include )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/isfqtconfig.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/isfqtconfig.h )

ADD_SUBDIRECTORY( src   )

IF( NOT ISFQT_IS_BUNDLED )
  ENABLE_TESTING()
  ADD_SUBDIRECTORY( tests )
ENDIF()


#### Project CMake configuration files creation ####

# Define the shortcuts for the installation directories
SET( INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/isf-qt"
                         CACHE STRING "Directory where the include files will be installed" )
SET( LIB_INSTALL_DIR     "${CMAKE_INSTALL_PREFIX}/lib"
                         CACHE STRING "Directory where the lib will be installed" )
SET( SHARED_INSTALL_DIR  "${CMAKE_INSTALL_PREFIX}/share"
                         CACHE STRING "Directory where the shared data will be installed" )

# Prepare thej IsfQtConfig.cmake file, which allows other projects to find us
CONFIGURE_FILE( cmake/IsfQtConfig.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/IsfQtConfig.cmake" @ONLY )


#### Installation ####

# Do not install the resources if we're bundling it into an application
IF( NOT ISFQT_IS_BUNDLED )
  INSTALL( FILES ${CMAKE_CURRENT_BINARY_DIR}/IsfQtConfig.cmake
          DESTINATION ${LIB_INSTALL_DIR}/isfqt )
  INSTALL( FILES cmake/FindIsfQt.cmake
          DESTINATION ${CMAKE_ROOT}/Modules )
ENDIF()

=== data/chatstyles/CMakeLists.txt ===

include_directories( ${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES}  )

add_subdirectory( Colourful-Enclosed )
add_subdirectory( Classic )
add_subdirectory( Classic-compact )
add_subdirectory( Dim )
add_subdirectory( Efficient )
add_subdirectory( Fresh )
add_subdirectory( Fresh-dark )
add_subdirectory( Pure )


########### install files ###############

install( FILES  examplemessage.xml DESTINATION ${DATA_INSTALL_DIR}/kmess/styles/ )

=== data/emoticons/CMakeLists.txt ===

ADD_SUBDIRECTORY( KMess2-new )

=== data/icons/CMakeLists.txt ===

KDE4_INSTALL_ICONS( ${ICON_INSTALL_DIR} )

SET( KMESS_ICON_INSTALL_DIR ${DATA_INSTALL_DIR}/kmess/icons/hicolor/16x16 )

# If Likeback is enabled, install the needed icons
IF( NOT ${KMESS_DISABLE_LIKEBACK} EQUAL 1 )
  INSTALL( FILES likeback_bug.png     DESTINATION ${KMESS_ICON_INSTALL_DIR}/actions )
  INSTALL( FILES likeback_dislike.png DESTINATION ${KMESS_ICON_INSTALL_DIR}/actions )
  INSTALL( FILES likeback_feature.png DESTINATION ${KMESS_ICON_INSTALL_DIR}/actions )
  INSTALL( FILES likeback_like.png    DESTINATION ${KMESS_ICON_INSTALL_DIR}/actions )
ENDIF( NOT ${KMESS_DISABLE_LIKEBACK} EQUAL 1 )

INSTALL( FILES kmess-shadow.png DESTINATION ${KMESS_ICON_INSTALL_DIR}/apps )

=== data/pics/CMakeLists.txt ===

SET( kmess_PICS
   away.png
   background.png
   berightback.png
   blocked.png
   busy.png
   emoticons.png
   empty.png
   invisible.png
   kmesspic.png
   kmessstrip1.png
   kmessstrip2.png
   lunch.png
   offline.png
   online.png
   onthephone.png
   unknown.png
   contact_away_overlay.png
   contact_busy_overlay.png
   contact_food_overlay.png
   contact_invisible_overlay.png
   contact_phone_overlay.png
)

INSTALL( FILES ${kmess_PICS} DESTINATION ${DATA_INSTALL_DIR}/kmess/pics )

=== debian/changelog ===
kmess (2.0.6.1-3) unstable; urgency=low

  * Add use_ssl_v3.diff, avoids disconnections each minute. (Closes: #697918)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Thu, 17 Jan 2013 22:34:48 +0100

kmess (2.0.6.1-2) unstable; urgency=high

  * Add follow-location-redirects.diff, this makes KMess usable with the latest
    changes in MSN servers. (Closes: #648080)
  * Update Vcs-* fields, this package was moved to git.
  * Bump Standards-Version to 3.9.2, no changes needed.
  * Add myself to Uploaders.
  * Urgency is high because this upload fixes an RC bug which affects testing.

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Wed, 09 Nov 2011 15:31:56 +0100

kmess (2.0.6.1-1) unstable; urgency=low

  * New Upstream Release (Closes: #602938, #610153).

  [ Ana Beatriz Guerrero Lopez ]
  * Remove Mario Iseli from Uploaders (MIA).

  [ George Kiagiadakis ]
  * Drop all patches; applied upstream.
  * Add myself to uploaders.
  * Drop dependency on libqca2-plugin-ossl; kmess now uses gcrypt.
  * Bump standards-version to 3.9.1; no changes required.
  * Add DEB_KDE_LINK_WITH_AS_NEEDED := yes to avoid uselessly
    linking on nepomuk and soprano libs.

 -- George Kiagiadakis <kiagiadakis.george@gmail.com>  Mon, 04 Apr 2011 14:28:04 +0300

=== debian/control ===
Source: kmess
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>, George Kiagiadakis <kiagiadakis.george@gmail.com>,
 José Manuel Santamaría Lema <panfaust@gmail.com>
Build-Depends: cdbs, debhelper (>= 7), automoc, pkg-kde-tools (>= 0.6.4), cmake,
 kdelibs5-dev, libgcrypt11-dev, libgif-dev, libkonq5-dev, libxml2-dev,
 libxslt1-dev, libxss-dev, zlib1g-dev
Standards-Version: 3.9.2
Homepage: http://kmess.org
Vcs-Git: git://git.debian.org/pkg-kde/kde-extras/kmess.git
Vcs-Browser: http://git.debian.org/?p=pkg-kde/kde-extras/kmess.git;a=summary

Package: kmess
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: konqueror
Description: MSN messenger for KDE
 An alternative MSN Messenger chat client for Linux. It allows Linux users
 to chat with friends who use MSN Messenger in Windows or Mac OS. The
 strength of KMess is it's integration with the KDE desktop environment,
 focus on MSN Messenger specific features and an easy-to-use interface.

=== debian/rules ===
#!/usr/bin/make -f

FILENAME = $(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz
UPFILENAME = $(DEB_SOURCE_PACKAGE)-$(shell echo $(DEB_UPSTREAM_VERSION) | sed 's/~//').tar.gz
URL = http://heanet.dl.sourceforge.net/$(DEB_SOURCE_PACKAGE)/$(UPFILENAME)

DEB_KDE_LINK_WITH_AS_NEEDED := yes

include /usr/share/pkg-kde-tools/makefiles/1/cdbs/kde.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_INSTALL_MANPAGES_kmess := debian/kmess.1
DEB_INSTALL_MENU_ARGS := debian/kmess.menu

=== debian/watch ===
version=3
#http://prdownloads.sourceforge.net/kmess/kmess-(.*)\.tar\.gz

# Find new files on sourceforge, for debscripts >= 2.9
opts="uversionmangle=s/rc/~rc/;s/beta/~beta/;s/alpha/~alpha/" \
 http://sf.net/kmess/kmess-(.*)\.tar\.gz debian svn-upgrade
